// Ukljucivanje standardnih biblioteka za ulaz/izlaz i fajla niz.h sa deklaracijama funkcija za rad sa nizovima
#include <stdio.h>
#include <stdlib.h>
#include "niz.h"

void sumaElemenata(int niz[], int n) {
	// Inicijalizujemo sumu na 0
	int suma = 0, i;
	// Zatim vrtimo for petlju od 0 do n i sabiramo sve clanove niza
	for (i = 0; i < n; i++) {
		suma += niz[i];
	}
	// Na kraju ispisujemo sumu elemenata
	printf("Suma elemenata niza je: %d\n", suma);
}

// Metoda koja ubacuje novi element niza 'niz' sa vrednoscu 'elem' na poziciji 'poz'
int ubaciNoviElement(int **niz, int *n, int poz, int elem) {
	int i;
	// Ukoliko je pozicija neodgovarajuca, vracamo signal greske
	if (poz < 0 || poz > *n) return -1;
	// Stari niz funkcijom realloc produzavamo za jedno polje
	int* tmpNiz;
	*niz = realloc(*niz, (*n + 1) * sizeof(int));
	// Ukoliko funkcija realloc nije uspela, vratice nam NULL, pa vrsimo tu proveru
	if (*niz == NULL) {
		return -1;
	}
	// Povecavamo broj elemenata niza
	*n = *n + 1;
	// Prolazimo kroz niz od kraja i pomeramo sve elemente za jednu poziciju udesno sve dok ne dodjemo
	// do pozicije 'poz' gde smestamo novi element niza
	for (i = *n - 1; i > poz; i--) {
		(*niz)[i] = (*niz)[i - 1];
	}
	(*niz)[poz] = elem;
	// Vracamo signal o uspesnosti funkcije
	return 0;
}