/*
	Kada prvi put ukljucimo fajl "niz.h", u tom trenutku nece biti definisana konstanta _NIZ_H_ pa ce #ifndef proci.
	Tada definisemo konstantu _NIZ_H_ i ostatak koda se kopira na mestu gde vrsimo ukljucivanje fajla "niz.h".
	Kada se sledeci put pokusa sa ukljucivanjem "niz.h" u istom fajlu, konstanta _NIZ_H_ je vec definisana ovog puta,
	pa ce ceo #ifndef da se preskoci, cime nece moci da dodje do duple definicije.
*/
#ifndef _NIZ_H_
#define _NIZ_H_

// Deklaracija funkcije koja sabira elemente niza
// Nizovi kroz parametre mogu da se prosledjuju kao niz[] ili kao *niz
void sumaElemenata(int niz[], int n);

// Deklaracija funkcije koja ubacuje novi element u niz
// Kako se svi parametri prenose po vrednosti, pa se sve promene nece videti van same funkcije,
// onda ukoliko zelimo da promenimo neki parametar cija ce promena biti vidljiva spolja, prosledjujemo ga
// kao pokazivac (int *n, da bismo promenili duzinu niza jer ubacujemo novi element)
//				 (int **niz, da bismo mogli da vratimo pokazivac koji sada pokazuje na veci deo dinamicke zone memorije)
int ubaciNoviElement(int **niz, int *n, int poz, int elem);

#endif
