#include <stdio.h>
#include <stdlib.h>
#include "list.h"

// Ova funkcija kreira listu od 'n' elemenata i vraca pokazivac na prvi element kao povratnu vrednost
Elem* kreirajListu(int n) {
	if (n <= 0) {
		printf("Neodgovarajuci broj elemenata liste\n");
		return NULL;
	}
	Elem *prvi = NULL, *tek = NULL;
	int i;
	printf("Unesite elemente liste:\n");
	// Prolazimo kroz for petlju i u svakom prolazu:
	for (i = 0; i < n; i++) {
		int broj;
		// ucitavamo nov broj
		scanf_s("%d", &broj);
		// kreiramo nov element strukture Elem
		Elem *novi = malloc(sizeof(Elem));
		// upisujemo broj u njegovo informaciono polje, a polje sledeci postavljamo na NULL
		novi->broj = broj;
		novi->sled = NULL;
		// ukoliko nemamo prvi element liste jos uvek
		if (prvi == NULL) {
			// onda je novokreirani element zapravo prvi element liste
			prvi = novi;
		}
		else {
			// a u suprotnom na poslednje dodat element nadovezujemo novokreirani
			tek->sled = novi;
		}
		// i na kraju novokreirani element proglasavamo za poslednje dodat element
		tek = novi;
	}
	return prvi;
}

// Ova metoda brise listu cime oslobadjamo dinamicku zonu memorije
void izbrisiListu(Elem *prvi) {
	// Dokle god postoji element liste
	while (prvi != NULL) {
		// cuvamo poziciju sledeceg elementa
		Elem *tek = prvi;
		prvi = prvi->sled;
		// a prethodni brisemo, i tako dalje prolazimo kroz listu
		free(tek);
	}
}

// Ova metoda ispisuje listu
void ispisiListu(Elem *prvi) {
	// Dokle god postoji element liste
	while (prvi != NULL) {
		// Ispisujemo informacioni deo elementa liste
		printf("%d ", prvi->broj);
		// A zatim se pozicioniramo na sledeci element
		prvi = prvi->sled;
	}
	printf("\n");
}